#include <stdio.h> // printf
#include <unistd.h> // fork
#include <wait.h> // wait
#include <stdlib.h> // exit

int main (void) {
	printf(" 1");
	fflush(stdout); // acrescenta-se para esvaziar o buffer
	int pid = fork();
	if (pid == -1) { // erro
		perror("impossivel criar um filho");
		exit(-1);
	} else if (pid == 0) { // filho
		printf(" 2");
		exit(0);
	} else { // pai
		wait(0); // o pai aguarda a morte do filho
		printf(" 3\n");
		exit(0);
	}
}