#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

int main(int argc, char *argv[]) {
	int n, numero, resultado, r1, r2;
	
	int filho1;
	int pipe_pai_para_filho1[2];
	int pipe_filho1_para_pai[2];
	
	int filho2;
	int pipe_pai_para_filho2[2];
	int pipe_filho2_para_pai[2];
	
	char mensagem[50] = "Testando mensagem";
	
	if (pipe(pipe_pai_para_filho1) < 0) perror("Erro no pipe...");
	if (pipe(pipe_filho1_para_pai) < 0) perror("Erro no pipe...");
	if (pipe(pipe_pai_para_filho2) < 0) perror("Erro no pipe...");
	if (pipe(pipe_filho2_para_pai) < 0) perror("Erro no pipe...");
	
	// Cria o filho 1
	if ((filho1 = fork()) == 0) { // pai
		// Cria o filho 2
		if ((filho2 = fork()) == 0) { // pai
			strcpy(mensagem, argv[1]);
			write(pipe_pai_para_filho1[1], mensagem, sizeof(mensagem));
			strcpy(mensagem, argv[1]);
			write(pipe_pai_para_filho2[1], mensagem, sizeof(mensagem)); 
			read(pipe_filho1_para_pai[0], mensagem, sizeof(mensagem));
			sscanf(mensagem, "%d", &r1);
			read(pipe_filho2_para_pai[0], mensagem, sizeof(mensagem));
			sscanf(mensagem, "%d", &r2);
			resultado = r1 + r2;
			printf("[pai]: %d + %d = %d\n", r1, r2, resultado);
		} else {
			read(pipe_pai_para_filho2[0], mensagem, sizeof(mensagem));
			sscanf(mensagem, "%d", &numero);
			resultado = numero*numero;
			sprintf(mensagem, "%d", resultado);
			printf("filho[%d]: %d**2 = %d\n", getpid(), numero, resultado);
			write(pipe_filho2_para_pai[1], mensagem, sizeof(mensagem));			
		}
	} else { // filho 1
		read(pipe_pai_para_filho1[0], mensagem, sizeof(mensagem));		
		sscanf(mensagem, "%d", &numero);
		resultado = 1;
		for (int i = 2; i <= numero; i++) {
		    resultado *= i;
		}
		sprintf(mensagem, "%d", resultado);
		printf("filho[%d]: %d! = %d\n", getpid(), numero, resultado);
		write(pipe_filho1_para_pai[1], mensagem, sizeof(mensagem));
	}
	sleep(1);
	exit(0);
}
